//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3C62B2230073.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3C62B2230073.cm

//## begin module%3C62B2230073.cp preserve=no
//## end module%3C62B2230073.cp

//## Module: MixComponent%3C62B2230073; Package specification
//## Subsystem: XSModel::Model::Component%367691A33718
//	/local/data/verisB/dorman/Xspec/src/component
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/Model/Component/MixComponent.h

#ifndef MIXCOMPONENT_H
#define MIXCOMPONENT_H 1

//## begin module%3C62B2230073.additionalIncludes preserve=no
//## end module%3C62B2230073.additionalIncludes

//## begin module%3C62B2230073.includes preserve=yes
//## end module%3C62B2230073.includes

// xsTypes
#include <main/xsTypes.h>
// Component
#include <XSModel/Model/Component/Component.h>
//## begin module%3C62B2230073.declarations preserve=no
//## end module%3C62B2230073.declarations

//## begin module%3C62B2230073.additionalDeclarations preserve=yes
//## end module%3C62B2230073.additionalDeclarations


//## begin MixComponent%362809DF00E6.preface preserve=yes
//## end MixComponent%362809DF00E6.preface

//## Class: MixComponent%362809DF00E6
//	A mixing model is a model that transcends data groups,
//	unlike other components that are specific to individual
//	data groups.
//
//	The syntax checker ensures that there is exactly one
//	Mixing model per Model.
//
//	Unlike other component types,
//	generated fit
//	parameters are unique, rather than multiplied by the
//	number of data groups.
//
//	Finally the mixing component depends on the data, not
//	just the response, in
//	a way that requires implementation.
//## Category: XSModel::Model::Component%3666B89A8340
//## Subsystem: XSModel::Model::Component%367691A33718
//## Persistence: Transient
//## Cardinality/Multiplicity: n



//## Uses: <unnamed>%3C62B9CF032A;ComponentBase { -> }
//## Uses: <unnamed>%3F940EF7009D;GroupFluxContainer { -> }

class MixComponent : public Component  //## Inherits: <unnamed>%3687BAB18948
{
  //## begin MixComponent%362809DF00E6.initialDeclarations preserve=yes
  //## end MixComponent%362809DF00E6.initialDeclarations

  public:
    //## Constructors (generated)
      MixComponent(const MixComponent &right);

    //## Constructors (specified)
      //## Operation: MixComponent%37EF90AE0538;    C++
      MixComponent (CGroupBase* p);

    //## Destructor (generated)
      virtual ~MixComponent();


    //## Other Operations (specified)
      //## Operation: clone%38E3B862A0D8
      virtual MixComponent* clone (CGroupBase* p) const;

      //## Operation: calculate%3AD2290F004B;            C++
      //	ConComponent::calculate() does  nothing, because
      //	convolution is applied to previously calculated flux
      //	array.
      //	The convolution is performed at the combination stage.
      virtual void calculate (bool saveComponentFlux, bool frozen);

      //## Operation: initialize%3F9D5A6B02AD
      void initialize ();

      //## Operation: perform%3F66204C0031
      void perform (const EnergyPointer& energy, GroupFluxContainer& flux, GroupFluxContainer& fluxError);

      //## Operation: verifyData%3F9EEA8300AB
      void verifyData () const;

      //## Operation: initializeForFit%3FA94F9C03E5
      virtual void initializeForFit ();

    // Additional Public Declarations
      //## begin MixComponent%362809DF00E6.public preserve=yes
      //## end MixComponent%362809DF00E6.public

  protected:
    // Additional Protected Declarations
      //## begin MixComponent%362809DF00E6.protected preserve=yes
      //## end MixComponent%362809DF00E6.protected

  private:

    //## Other Operations (specified)
      //## Operation: copy%3A953EB90011
      virtual void copy (const Component& right);

    // Additional Private Declarations
      //## begin MixComponent%362809DF00E6.private preserve=yes
      //## end MixComponent%362809DF00E6.private

  private: //## implementation
    // Additional Implementation Declarations
      //## begin MixComponent%362809DF00E6.implementation preserve=yes
      //## end MixComponent%362809DF00E6.implementation

};

//## begin MixComponent%362809DF00E6.postscript preserve=yes
//## end MixComponent%362809DF00E6.postscript

// Class MixComponent 

//## begin module%3C62B2230073.epilog preserve=yes
//## end module%3C62B2230073.epilog


#endif
